"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WithStore = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var WithStoreContext = _react.default.createContext({
  store: {}
});

var WithStore =
/*#__PURE__*/
function (_React$Component) {
  _inherits(WithStore, _React$Component);

  function WithStore() {
    _classCallCheck(this, WithStore);

    return _possibleConstructorReturn(this, _getPrototypeOf(WithStore).apply(this, arguments));
  }

  _createClass(WithStore, [{
    key: "render",
    value: function render() {
      var _this = this;

      return _react.default.createElement(WithStoreContext.Consumer, null, function (_ref) {
        var store = _ref.store;
        return _react.default.createElement(WithStoreInner, _extends({
          store: store
        }, _this.props), _this.props.children);
      });
    }
  }]);

  return WithStore;
}(_react.default.Component);

exports.WithStore = WithStore;

_defineProperty(WithStore, "Provider", function (_ref3) {
  var value = _ref3.value,
      children = _ref3.children;
  return _react.default.createElement(WithStoreContext.Provider, {
    value: value
  }, children);
});

var WithStoreInner =
/*#__PURE__*/
function (_React$Component2) {
  _inherits(WithStoreInner, _React$Component2);

  function WithStoreInner(_ref2) {
    var _this2;

    var store = _ref2.store,
        selector = _ref2.selector;

    _classCallCheck(this, WithStoreInner);

    _this2 = _possibleConstructorReturn(this, _getPrototypeOf(WithStoreInner).call(this));
    var state = store.getState();
    var dprops = selector(state);
    _this2.state = _objectSpread({}, dprops);
    return _this2;
  }

  _createClass(WithStoreInner, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this3 = this;

      this.unsubscribe = this.props.store.subscribe(function () {
        if (_this3.unmounted) return;

        var state = _this3.props.store.getState();

        var props = _this3.props.selector(state);

        _this3.setState(_objectSpread({}, props));
      });
      this.unmounted = false;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.unmounted = true;
      this.unsubscribe();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          store = _this$props.store,
          render = _this$props.render,
          children = _this$props.children;
      return render ? render(this.state, store.dispatch) : children(this.state, store.dispatch);
    }
  }]);

  return WithStoreInner;
}(_react.default.Component);